# coding: utf-8

"""
    OpenBuckets API

    The OpenBuckets web-based tool is a powerful utility that allows users to quickly locate open buckets in cloud storage systems through a simple query. In addition, it provides a convenient way to search for various file types across these open buckets, making it an essential tool for security professionals, researchers, and anyone interested in discovering exposed data. This Postman collection aims to showcase the capabilities of OpenBuckets by providing a set of API requests that demonstrate how to leverage its features. By following this collection, you'll learn how to utilize OpenBuckets to identify open buckets and search for specific file types within them.

    The version of the OpenAPI document: 1.0.0
    Contact: support@openbuckets.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class BucketSearchResultsBucketsInner(BaseModel):
    """
    Details about each bucket.
    """
    cloud_provider: Optional[StrictStr] = Field(None, alias="cloudProvider", description="The cloud provider where the bucket is hosted.")
    file_count: Optional[StrictInt] = Field(None, alias="fileCount", description="The number of files in the bucket.")
    id: Optional[StrictInt] = Field(None, description="The unique identifier for the bucket.")
    indexed_at: Optional[datetime] = Field(None, alias="indexedAt", description="The date and time when the bucket was last indexed.")
    url: Optional[StrictStr] = Field(None, description="The URL of the bucket.")
    __properties = ["cloudProvider", "fileCount", "id", "indexedAt", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BucketSearchResultsBucketsInner:
        """Create an instance of BucketSearchResultsBucketsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BucketSearchResultsBucketsInner:
        """Create an instance of BucketSearchResultsBucketsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BucketSearchResultsBucketsInner.parse_obj(obj)

        _obj = BucketSearchResultsBucketsInner.parse_obj({
            "cloud_provider": obj.get("cloudProvider"),
            "file_count": obj.get("fileCount"),
            "id": obj.get("id"),
            "indexed_at": obj.get("indexedAt"),
            "url": obj.get("url")
        })
        return _obj


